//+------------------------------------------------------------------+
//|                                                   cross idou.mq4 |
//|                                                                A |
//+------------------------------------------------------------------+
#property copyright "A"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Blue
#property indicator_width1 3
#property indicator_color2 Red
#property indicator_width2 3
#property indicator_color3 Blue
#property indicator_width3 3
#property indicator_color4 Red
#property indicator_width4 3
#property indicator_color5 Yellow
#property indicator_color6 Green

double BufBuy[];
double BufSell[];
double BufBuyClose[];
double BufSellClose[];
double FastMA[];
double SlowMA[];
double trend[];





extern int  idou            = 26;
extern int  MA              = 26;
extern int  MA_idou         = 20;
extern bool alertsOn        = false;
extern bool alertsMessage   = true;
extern bool alertsSound     = false;
extern bool alertsEmail     = false;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(7);
   SetIndexBuffer(0,BufBuy);       SetIndexLabel(0,"Buy");             SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID,2); SetIndexArrow(0,233); 
   SetIndexBuffer(1,BufSell);      SetIndexLabel(1,"Sell");            SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID,2); SetIndexArrow(1,234); 
   SetIndexBuffer(2,BufBuyClose);  SetIndexLabel(2,"BuyClose");        SetIndexStyle(2,DRAW_ARROW,STYLE_SOLID,2); SetIndexArrow(2,251); 
   SetIndexBuffer(3,BufSellClose); SetIndexLabel(3,"SellClose");       SetIndexStyle(3,DRAW_ARROW,STYLE_SOLID,2); SetIndexArrow(3,251); 
   SetIndexBuffer(4,FastMA);       SetIndexLabel(4,"MA"+MA); SetIndexStyle(4,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(5,SlowMA);       SetIndexLabel(5,"MA"+idou); SetIndexStyle(5,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(6,trend);
   
  SetIndexEmptyValue(5,0.0);
   return(0);
  }

//
//
//
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMax(MathMin(Bars-counted_bars,Bars-1),idou+1);
   
   for(int i=limit-1; i>=0;i--)
   {
      FastMA[i] = iMA(NULL,0,MA,0,MODE_SMA,PRICE_CLOSE,i);
      SlowMA[i] = iMA(NULL,0,MA_idou,-1*idou,MODE_SMA,PRICE_CLOSE,i);

      BufBuy[i]  = EMPTY_VALUE;
      BufSell[i] = EMPTY_VALUE;
      trend[i] = trend[i+1];

      if(SlowMA[i] != 0){
         if(FastMA[i+1] >SlowMA[i+1] && FastMA[i] < SlowMA[i]) { BufBuy[i]  =Close[i]; trend[i] =  1; }
         if(FastMA[i+1] <SlowMA[i+1] && FastMA[i] > SlowMA[i]) { BufSell[i] =Close[i]; trend[i] = -1; }
      }
   }
   manageAlerts();
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (trend[0] ==  1) doAlert("up");
      if (trend[0] == -1) doAlert("down");
   }
} 
void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   string message;
   
      if (previousAlert != doWhat) {
          previousAlert  = doWhat;

          //
          //
          //
          //
          //

          message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" MA cross idou current trend is "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," MA cross idou"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}